发布日期：`2021-10-19`

- ## 新增功能
	- 分布式调度调整
		- 注意：在定时任务属性中设置中，增加了`调度系统`选项，需要确认，默认设置为管理系统后台
	- 增加单页面预览功能（一般用于移动端访问单页面内容）
		- 主页访问：http://域名/gdpaas/home/page.htm?pageId=PG-9CFB-7C22-07804FD4
		- 子页访问：http://域名/gdpaas/home/detail.htm?pageId=PG-4530-B938-6F1A4CF2&COMPANY_CODE=000001
		- 注意事项：
			- `pageId`必须是页面编码
			- 可以传参给具体页面（除`pageId`外其他所有参数都会传递给页面，页面可以在onOpen事件中获取）
	- 运行环境->系统设置菜单中，增加`运行系统管理`，可以查看当前集群体系下所有在运行的服务，以及运行服务的版本信息；同时支持日志文件的查看和下载
	- 主数据表格`mainTable`支持子查询，用法如下：
	```sql
	SELECT 
		A.USER_ID,
		B.AREA_PROVINCE,
		B.DATA_EDIT_DEPT,
		B.ROW_COUNT ,
		'' AS STATUS_NAME,
		'' AS DEPT_NAME,
		B.DATA_SYSTEMDATE,
		A.USER_NAME
	FROM (
		SELECT 
			AREA_PROVINCE,DATA_EDIT_DEPT,COUNT(0) AS ROW_COUNT,DATA_SYSTEMDATE
		FROM BASIC_COMPANY
		WHERE AREA_PROVINCE = :AREA_PROVINCE
		AND DATA_EDIT_DEPT = :DATA_EDIT_DEPT
		AND DATA_SYSTEMDATE = :DATA_SYSTEMDATE
		GROUP BY AREA_PROVINCE,DATA_EDIT_DEPT,DATA_SYSTEMDATE
	) B LEFT JOIN BASIC_USER A ON A.DEPT_CODE = B.DATA_EDIT_DEPT
	WHERE A.USER_NAME = :USER_NAME
	```
	注意事项：
		- 查询条件必须用 `:xxx`来定位，此处的定位必须是在 `and` 或者 `where`内，且SQL变量必须在等式的右边，以表示这个查询条件在此处产生作用。
		- 对于存在值反射是下拉列，SQL变量请使用值字段

	>[warning] 关于子查询数据权限
	
	```
	SELECT *
	FROM (
  		SELECT AREA_PROVINCE,DATA_EDIT_DEPT,ORG_CODE,COUNT(0) AS ROW_COUNT,DATA_SYSTEMDATE
  		FROM BASIC_COMPANY
  		WHERE AREA_PROVINCE = :AREA_PROVINCE
		AND DATA_EDIT_DEPT = DATA_AUTH('DEPT_CODE')
  		GROUP BY AREA_PROVINCE,DATA_EDIT_DEPT,DATA_SYSTEMDATE
	) B LEFT JOIN BASIC_USER A ON A.DEPT_CODE = B.DATA_EDIT_DEPT
	WHERE A.USER_NAME = :USER_NAME AND B.ORG_CODE = DATA_AUTH('ORG_CODE')
	```
	默认情况下，子查询是不自动添加数据权限的，需要数据权限则需要手动添加数据权限锚点，注意，此例中的`BASIC_USER`属于实体表，此表会自动添加数据权限。
		
	- 主数据表格`mainTable`支持`UNION ALL`查询，用法如下：
	```sql
	SELECT 
		COMPANY_CODE AS CODE, COMPANY_NAME AS NAME, DATA_EDIT_DEPT AS DEPT_CODE, 
		DATA_SYSTEMDATE AS DATA_SYSTEMDATE,
		'' AS DEPT_NAME
	FROM BASIC_COMPANY
	WHERE COMPANY_CODE = :CODE
	AND COMPANY_NAME = :NAME
	AND DATA_EDIT_DEPT = :DEPT_CODE
	AND DATA_SYSTEMDATE = :DATA_SYSTEMDATE
	UNION ALL
	SELECT 
		USER_ID AS CODE,USER_NAME AS NAME,DEPT_CODE ,ADD_DATE,'' AS DEPT_NAME
	FROM BASIC_USER
	WHERE USER_ID = :CODE
	AND USER_NAME = :NAME
	AND DEPT_CODE = :DEPT_CODE
	AND ADD_DATE = :DATA_SYSTEMDATE
	```
	注意事项：
		- 查询条件必须用 `:xxx`来定位，此处的定位必须是在 `and` 或者 `where`内，且SQL变量必须在等式的右边，以表示这个查询条件在此处产生作用。
		- 对于存在值反射是下拉列，SQL变量请使用值字段
	
	- 开发环境：`模块开发`、`过程函数`增加代码版本对比功能。
	- 消息模版设置中，增加直接打开单据详情设置，不再需要通过主页面中转。