发布日期：`2021-01-20`

- ## 新增功能
	- 多语言支持
	- 外部接口调用支持
	- 增加一个帐号同时只能登录一次的功能
	- SQLTools增加时间差计算函数
		- `SQLTools.dateIntervalDAY(date1,date2)` : 返回两个日期相差的天数
		
		```sql
		    select  
			    field,
				SQLTools.dateIntervalDAY(SQLTools.getDate(),date2) as dateNum
			from table
		```
		等效于
		````sql
		    select 
				field,
				(
					(
						SQLTools.toDate(SQLTools.toChar(SQLTools.getDate(), 'yyyy-MM-dd'), 'yyyy-MM-dd')
						- 
						SQLTools.toDate(SQLTools.toChar(date2, 'yyyy-MM-dd'), 'yyyy-MM-dd'))) AS dateNum
			from table
		````
		
		- `SQLTools.dateIntervalMONTH(date1,date2)` : 返回两个日期相差的月数
		- `SQLTools.trimTime(date)` : 截断日期中的时间
		```sql
			select SQLTools.trimTime(SQLTools.getDate()) from dual // 返回2020-01-20 00:00:00
			
		```
	- `SQLTools`增加取查询结果前几条数据的语法
	```sql
		select SQLTools.top(10) * from table where id>100
	```
	等效于（oracle为例）
	```sql
		select * from table where id>100 and rownum <= 10
	```
	
	`$vs.billNoTools`增加批量获取单据号码函数：
		- `$vs.billNoTools.getBatchBillNo($form,$count):list`
		可以一次性返回指定个数（`$count`）的单据号码