发布日期：`2021-08-13`

- ## 新增功能
	- 移动端浏览器优化：使用手机访问谷神系统的UI优化
	- 查询日期时间段控件优化
	- 开发环境：增加系统脚本产品导出更新到项目功能
	- 修复`oracle`数据库下，用户自定义sql执行方法在参数为空的情况下报错问题
	- 谷神资源管理服务增加产品切分支版本功能
	- 开发环境：按钮、布局行、布局列增加`className`样式名称
	- `TabPage`控件增加添加角标函数`tabPage.tabPage0.addBadge(text,bgcolor)`
	- 增加产品升级到项目的升级报告
	- 项目升级时，控件数据源合并算法优化
	- 项目页面增加恢复出厂功能，用于还原产品版本
	- 增加企业微信集成功能，扫码登录、发送消息
	- 开发环境：应用登录设置增加是否开启扫码登录功能
	- 增加xml解析函数`$vs.util.parseXml($xml:string,$charset:string)`，用法如下：
	```
	#set($xml='<business id="zzsfp" comment="KPTZ210911003">')
	#set($xml= $xml + '<body yylxdm="1">')
	#set($xml= $xml + '  <kpxx>')
	#set($xml= $xml + '    <gfmc>wzx测试数据</gfmc>')
	#set($xml= $xml + '    <sh>000000000000000000</sh>')
	#set($xml= $xml + '  </kpxx>')
	#set($xml= $xml + '  <list>')
	#set($xml= $xml + '    <item id="1">')
	#set($xml= $xml + '      <mc>螺纹钢</mc>')
	#set($xml= $xml + '      <cz>Q235B</cz>')
	#set($xml= $xml + '    </item>')
	#set($xml= $xml + '    <item id="2">')
	#set($xml= $xml + '      <mc>热轧钢</mc>')
	#set($xml= $xml + '      <cz>Q455B</cz>')
	#set($xml= $xml + '    </item>')
	#set($xml= $xml + '  </list>')
	#set($xml= $xml + '  <goods>')
	#set($xml= $xml + '    <qut>1</qut>')
	#set($xml= $xml + '    <name>密码</name>')
	#set($xml= $xml + '  </goods>')
	#set($xml= $xml + '  <goods>')
	#set($xml= $xml + '    <qut>2</qut>')
	#set($xml= $xml + '    <name>其他</name>')
	#set($xml= $xml + '  </goods>')
	#set($xml= $xml + '</body>')
	#set($xml= $xml + '</business>')
	
	#set($root = $vs.util.parseXml($xml)) // 解析XML字符串
	
	$root.getAttrsValue('comment') // 获取顶级节点属性，此处返回：KPTZ210911003
	
	$root.body.kpxx.isNull()  // <-- 判断节点是否存在，此处返回false
	$root.body.kpxx.isNotNull()  // <-- 判断节点是否存在，此处返回true
	$root.body.kpxx.item.isNull()  // <-- 判断节点是否存在，此处返回true
	
	$vs.log.info("body:attr:yylxdm:"+$root.body.getAttrsValue('yylxdm')) // 获取节点属性（若节点不存在，则返回null值） --> 1
	$vs.log.info("body.kpxx.gfmc:"+$root.body.kpxx.gfmc.getText()) // 获取节点文本（若节点不存在，则返回null值） --> wzx测试数据
	$vs.log.info("name:" + $root.body.getName()) // 获取节点名称（若节点不存在，则返回null值） --> body
	$vs.log.info("list1:" + $root.body.list.getList('item')) // 获取列表
	$vs.log.info("list2:" + $root.body.list.item) // 获取列表（不推荐此方法，此方法是根据xml元素个数，有可能返回list也有可能返回object）
	#set($list = $root.body.list.getList('item'))
	#foreach($item in $list)
		$vs.log.info($item.mc.getText())
	#end
	
	#set($data = $root.body.toDataMap())  // <-- 将节点数据保存为标准数据结构（任意节点都可调用）
	#set($json = $root.body.kpxx.toJson()) // <-- 将节点数据输出为json字符串（任意节点都可调用）
	```
	- 表格属性字段列表中，增加隐藏属性列
	- 表格属性设置中，增加`点击选择行`设置，默认开启，表示允许点击行内任意位置选择本行，若取消，则表示必须点击第一列的checkbox来选择本行数据
	- 以下表格函数增加参数：`isNotFilter`，是否在设置数据后不自动触发过滤操作（默认触发，主要用于大数据下表格刷新延时问题）
		- `table.setRowData(row,isNotFilter)`
		- `table.update(row,index,isNotFilter)`
		- `table.addNewRow(data,addIndex,isNotFilter)`
		- `table.copySelectRow(callback,isNotFilter)`
	- 以下表格函数增加参数：`isNotRefresh`:本次操作禁用刷新，一般用于批量操作减少表格的更新频率，待批量操作完成后手工调用 `table.reDrawRow(-1)`来全表格刷新
		- `table.setRowData(row,isNotFilter)`
		- `table.removeRowStyle(rowIndex,isNotRefresh)`
		- `table.setCellStyle(rowIndex,fieldId,style,isNotRefresh)`
		- `table.removeCellStyle(rowIndex,fieldId,isNotRefresh)`
		- `table.clearCellStyle(fieldId,isNotRefresh)`
		- `table.update(row,index,isNotRefresh)`
		- `table.setDisableEdit(rowIndex,fieldId,canEdit,isNotRefresh)`
		- `table.disabledOptButton(rowIndex,bntAliasName,isNotRefresh)`
		- `table.enabledOptButton(rowIndex,bntAliasName,isNotRefresh)`
		- `table.showOptButton(rowIndex,bntAliasName,isNotRefresh)`
		- `table.hideOptButton(rowIndex,bntAliasName,isNotRefresh)`
	- 模块（菜单）属性中，增加如下三种功能：
		- `关联菜单`：此功能可以将其他微服务的菜单挂载到当前微服务（权限分配时看不到此菜单，仍旧需要到原微服务菜单上进行权限分配）
		- `外部连接（新窗口）`：可以配置外部系统的菜单（url可以编程），用于打开新的外部系统窗口
		- `外部连接（工作区）`：可以配置外部系统的菜单（url可以编程），用于在工作区打开新的外部系统页面
	- 增加授权文件读取功能
		- `$vs.properties.getRegSystems()`:获取授权文件里授权的系统编码。
		- `$vs.properties.getRegModels()`:获取授权模块列表（null or empty 表示所有模块）
		- `$vs.properties.getRegDisabledMenus()`:获取禁用菜单（null or empty 表示无）
		- `$vs.properties.getRegDate()`:获取授权日期。
		- `$vs.properties.getRegLastDate()`:获取授权截止日期
		- `$vs.properties.getRegPublisher()`:获取授权文件颁发单位名称
		- `$vs.properties.getRegUnitName()`:获取授权文件使用单位名称。
		- `$vs.properties.getRegOtherConfig()`:获取授权文件中其他配置项。
		- `$vs.properties.getRegMaxOrg()`:获取授权文件里的授权最大机构数。
		- `$vs.properties.getRegMaxUser()`:获取授权文件里的授权用户数。注意：用户数为启用用户数，对于停用用户不在计数之内；若启用用户数超过规定数，则系统自动禁用相关多余的账户