## 关于文件服务
谷神系统默认配套的是，高达基于Java技术、采用内嵌FTP组件的文件系统`GoldenFS`。

## 文件服务的安装
文件系统需要依赖于Tomcat容器，您可以下载集成安装包
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_67b0dc8f527877a3e30d100b2827ff2a_r.png)
此包为win和linux通用包。

### linux下安装文件服务
  1. 请先确保您的目标服务器已经安装好了JDK环境（1.8及以上版本）
  2. 上传文件服务安装包到目标服务器
     建议文件服务器安装到linux的独立分区，这样一旦操作系统损坏需要重装可以还原文件
	![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_8c27818d5c34c9d2f4b741ff0890389f_r.png)
  3. 登录SSH修改文件服务器的配置
    - 解压缩文件：`[localhost data] # unzip tomcat-8.fileservice.zip`
	![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_b6e4762d9cd955c309cc281cf10712cb_r.png)
	解压缩后可以得到几个`tomcat-8`的程序包
	- 进到程序执行目录`[localhost data] # cd tomcat-8/bin`
	- 修改运行配置文件`[localhost bin] # vi catalina.sh`
		![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_74f83bda0ac6b4b40bc00c568a584967_r.png)
		把画红线的部分修改为您本地java安装的目录

  4.文件服务器配置，打开并编辑文件
  	![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_fa4eff3ce90d895fa97cf9bd8a63c706_r.png)
  	![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_d34f8570bf541c709e773f435f26e434_r.png)

  > [success] 一般情况下，这些配置您保存默认即可
  
	- `ftp.random-port`为文件服务器传输文件时的随机端口，若本地操作系统开启了防火墙，则需要打开这些端口允许其他服务器访问。
	- `ftp.root-path-level`：为文件服务器主目录层级，默认 `0` ，新安装的服务建议设置为 `2` （即去掉这行的注释）
  5. 开放防火墙端口（若操作系统已启用防火墙）：

序号|端口|说明
:-:	|:-|:-
1	|8080|文件服务对外的WEB访问端口(通常为通过nginx代理到公网)
2	|2100|文件服务对其他服务的命令端口（仅内网开放，禁止公布到公网）
3	|10000-10500|文件上传/下载端口（仅内网开放，禁止公布到公网）


  - 防火墙开放指令示例：
	- `[localhost] # firewall-cmd --permanent --zone=public --add-port=8080/tcp`
	- `[localhost] # firewall-cmd --permanent --zone=public --add-port=2100/tcp`
	- `[localhost] # firewall-cmd --permanent --zone=public --add-port=10000-10500/tcp`
	- 立即生效防火墙： `[localhost] # firewall-cmd --reload`
	- 列出所有的开放端口 : `firewall-cmd --list-all`
	
6.注册服务到系统（CentOs7以上版本）
  
	- 进到程序执行目录`[localhost data] # cd /data/tomcat-8/bin`
	- 编辑服务启动文件`[localhost bin] # vi tomcat8.service`	
	![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_65e682d7389d4555da45ee9d6b7ff8f3_r.png)
	将红线标注的几个配置为您tomcat的安装目录
	- 复制启动文件到系统脚本区`[localhost bin] # cp tomcat8.service /usr/lib/systemd/system`
	- 生效并设为自动启动服务`[localhost bin] # systemctl enable tomcat8`
	- 生效并设为自动启动服务`[localhost bin] # systemctl daemon-reload`
	- 启动服务`[localhost bin] # systemctl start tomcat8`
	- 停止服务`[localhost bin] # systemctl stop tomcat8`
	
## 升级文件服务
要升级文件服务，则需要拿到最新的文件服务安装包或者文件服务程序包，本例以文件服务程序包为例来说明文件服务的升级过程。

文件服务程序包名称为![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_7f3e60dc0b3d71f151adad901db34153_r.png)
拿到后，请解压缩此包，得到如下文件目录：
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_d03ab38ceeae6dad3156d4b6ce4c03f6_r.png)

- 停止服务器上的文件服务，并删除下图红线部分的目录
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_1d2496eb5b705929262c613d52063e2f_r.png)

- 把本地解压的文件覆盖到服务器上即可。

> [success] 提示：请尽量使用谷神部署工具来安装文件服务