> [success] 提示：请尽量使用谷神部署工具来安装谷神服务

##  发布配置
1、	登录谷神开发平台后，选择**系统管理**->**应用管理**菜单，进行系统发布
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_28fa524a80905e7b7d06382d41f00db4_r.png)
2、	点击需要发布的系统的**发布**按钮，进入发布配置界面
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_de1296594fb9c2ac8d4753c7202a15cb_r.png)
3、	发布配置界面可以根据不同的环境设置不同的发布设置，点击**+**新增发布设置
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_800422c2855afa708b5f1726886c84be_r.png)
4、	根据项目的实际环境配置相关参数，若当前服务为微服务，则需要配置微服务的发现服务。
5、	配置完成后，点击“导出执行包”以导出包，**注：导出升级包功能暂不支持**
 ![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_b59e46c07a406ba76462bd856ad4e958_r.png)
6、	点击确定导出时，系统需要编译相关代码，可能需要等待一段时间，当出现**下载**按钮时，表示执行包已准备就绪，而已开始下载执行包了
 ![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_f2d85324215e63bfc01e3c07f2193a9e_r.png)
7、	下载好后，就进入下一环境，系统升级环节。

## 可执行包
### 1、可执行包分类
谷神系统根据系统的属性，分为基础系统和微服务系统两类，其中，基础系统集成了用户登录、网关路由、对外访问等功能

### 2、可执行包名称解释
当您下载了可执行包后，您得到的是一个压缩文件，文件名称可能为“**gusenrun-\***”或者“**gusenbasic-\***”开头的文件，文件名称的意思是
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_90c22e1a6b169a41a2a8eb6ebd78b341_r.png)
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_169bd8032e181a0e811b8b2c75b5cea5_r.png)
* gusenbasic 开头的包，表示当前服务包为基础服务的可执行包；gusenrun开头的包，表示当前服务包为微服务可执行包。
* SYS-\*\* 这一串代表当前导出的系统编码
* 最后一串数字表示当前导出包的批号（日期时间）

## 系统安装
当升级包导出后，根据服务性质不同，分为可登录的基础服务和微服务两种情况。基础服务中含有用户登录功能、网关路由功能等。
### 1、基础服务安装
* **目录结构**
解压缩基础服务包后，您会得到下列目录：
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_28b46836f6a3337f81618dd8a774cad6_r.png)

文件|说明
:-:	|:-
**libs**|配置文件及插件jar包存放的路径
**routeconfig**|路由配置文件信息（系统启动后自动删除）
**upgrade**|升级文件信息（系统启动后自动删除）
**webresources**|静态页面（含编译后的页面）信息
**gusenbasic-\*\*.jar**|启动程序包
**service.sh**|linux下使用的启动器，若服务器为window，则另外定时启动文件

* **安装服务**
将导出来的压缩包，如（gusenbasic-\*\*.zip）直接上传到linux服务器，然后使用unzip命令解压缩包（注意事先请先创建安装目录），然后对servcie.sh文件进行执行授权。然后直接执行 ./service.sh start 启动服务即可；停止服务使用 ./service.sh stop命令。
```shell
cd /home
mkdir rundir
cd rundir
unzip gusenbasic….
chmod a+x service.sh
```

### 2、微服务安装
* **目录结构**
解压缩微服务包后，您会得到下列目录：
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_382f2ece4b1efe4dbd06c75e3287dea2_r.png)
	* **run-pack** 可执行包
	* **basic-pack.zip** 网关升级文件
进到run-pack目录，文件结构为：
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_36be5dca9ab10f12397a865bc440ca2c_r.png)

文件|说明
:-:	|:-
**libs**|配置文件及插件jar包存放的路径
**upgrade**|升级文件信息（系统启动后自动删除）
**gusenrun-\*\*.jar**|启动程序包
**service.sh**|linux下使用的启动器，若服务器为window，则另外定时启动文件

* **安装服务**
解压缩得到的目录，run-pack直接上传到linux服务器，然后对servcie.sh文件进行执行授权。然后直接执行**./service.sh start**启动服务即可；停止服务使用**./service.sh stop**命令。
```shell
cd /home
mkdir rundir
cd rundir
chmod a+x service.sh
```
* **更新网关升级文件（必须）**
将得到的“**basic-pack.zip**”解压，得到路由配置文件
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_472689d6fd9d766a248a682b8427c1c4_r.png)
需要将里面的文件覆盖到基础服务平台（**注意，前提必须是基础服务平台已经成功启动，且基础服务平台的routeconfig目录没有任何文件**），并重启基础平台服务。
自此服务安装完成。