本插件为谷神整合RocketMQ调用的插件，若您项目需要使用，则使用步骤如下：
1.  下载插件包：
	 - [guthon-plugins-rocketmq-1.0-SNAPSHOT.jar](https://file.guthon.com/fileservice/download/guthon-plugins-rocketmq-1.0-SNAPSHOT.jar)
	 - 插件编码：`com.guthon.plugin.rocketmq`
2. 上传插件包到您需要调用的项目中
3. 配置插件：
```yaml
	golden.rocket.namesrv = RocketMQ命名服务地址及端口，集群模式下可以用“,”分隔，如：192.168.0.190:9876
	golden.rocket.consume-thread-min = 4 # （非必须）最小线程数
	golden.rocket.consume-thread-max = 4 # （非必须）最大线程数
	golden.rocket.consume-timeout = 15 #（非必须）最长的消费时间（单位：分钟）
	golden.rocket.max-reconsume-times=-1 #（非必须）最大重试次数（-1无限）
```
4. 重启服务后，即可访问内置API进行MQ消息操作（具体相见API说明文档）：
	 - `$vs.mq.subscribe($topic:string,$tag:string,$procName:string,$funName:string,$accessKey:string,$secretKey:string):void`
	 - `$vs.mq.send($topic:string,$tag:string,$data:object):SendResult`
	 - `$vs.mq.batchSend($topic:string,$tag:string,$datas:List<object>):SendResult`
	 - `$vs.mq.start($topic:string,$accessKey:string,$secretKey:string):boolean` 
5. 包含依赖包及版本：

序号|groupId				|artifactId			  |版本
:-|:-						|:-							|:-
1 | commons-cli				| commons-cli 				| 1.2
2 | commons-digester		| commons-digester 			| 1.2
3 | commons-validator		| commons-validator 		| 1.7
4 | org.lz4					| lz4-java 					| 1.8.0
5 | io.netty				| netty-all 				| 4.1.84.Final
6 | io.netty				| netty-buffer 				| 4.1.84.Final
7 | io.netty				| netty-codec 				| 4.1.84.Final
8 | io.netty				| netty-codec-dns 			| 4.1.84.Final
9 | io.netty				| netty-codec-haproxy 		| 4.1.84.Final
10| io.netty				| netty-codec-http 			| 4.1.84.Final
11| io.netty				| netty-codec-http2 		| 4.1.84.Final
12| io.netty				| netty-codec-memcache 		| 4.1.84.Final
13| io.netty				| netty-codec-mqtt 			| 4.1.84.Final
14| io.netty				| netty-codec-redis 		| 4.1.84.Final
15| io.netty				| netty-codec-smtp 			| 4.1.84.Final
16| io.netty				| netty-codec-socks 		| 4.1.84.Final
17| io.netty				| netty-codec-stomp 		| 4.1.84.Final
18| io.netty				| netty-codec-xml 			| 4.1.84.Final
19| io.netty				| netty-common 				| 4.1.84.Final
20| io.netty				| netty-handler 			| 4.1.84.Final
21| io.netty				| netty-transport-native-unix-common 	| 4.1.84.Final
22| io.netty				| netty-handler-proxy 		| 4.1.84.Final
23| io.netty				| netty-resolver 			| 4.1.84.Final
24| io.netty				| netty-resolver-dns 		| 4.1.84.Final
25| io.netty				| netty-transport 			| 4.1.84.Final
26| io.netty				| netty-transport-rxtx 		| 4.1.84.Final
27| io.netty				| netty-transport-sctp 		| 4.1.84.Final
28| io.netty				| netty-transport-udt 		| 4.1.84.Final
29| io.netty				| netty-transport-classes-epoll 		| 4.1.84.Final
30| io.netty				| netty-transport-classes-kqueue 		| 4.1.84.Final
31| io.netty				| netty-resolver-dns-classes-macos 		| 4.1.84.Final
32| io.netty				| netty-transport-native-epoll 			| 4.1.84.Final
33| io.netty				| netty-transport-native-kqueue 		| 4.1.84.Final
34| io.netty				| netty-transport-native-macos 			| 4.1.84.Final
35| commons-validator		| commons-validator 		| 1.7
36| commons-digester		| commons-digester 			| 2.1
37| org.apache.rocketmq		| rocketmq-client 			| 4.9.5
38| org.apache.rocketmq		| rocketmq-common 			| 4.9.5
39| org.apache.rocketmq		| rocketmq-acl 				| 4.9.5
40| org.apache.rocketmq		| rocketmq-remoting 		| 4.9.5
41| org.apache.rocketmq		| rocketmq-logging 			| 4.9.5
42| org.apache.rocketmq		| rocketmq-srvutil 			| 4.9.5
43| com.github.luben		| zstd-jni 					| 1.5.2-2