本插件为谷神整合基于AWS S3技术标准的云对象存储OSS接口插件，若您项目需要使用，则使用步骤如下：
1. 目前已知可使用的平台：楚天云
2. 下载插件包：
	 - [guthon-plugins-oss-aws-1.0-SNAPSHOT.jar](https://file.guthon.com/fileservice/download/guthon-plugins-oss-aws-1.0-SNAPSHOT.jar)
	 - 插件编码：`com.guthon.plugin.oss.aws`
3. 上传插件包到您需要调用的项目中（所有微服务及主数据服务都需要关联使用）
4. 配置插件：
```yaml
# 文件服务器外网共有区访问根地址（同谷神配套版设置），通常为：${guthon.file-service.oss.root-domain}/[bucket2]
golden.file-service.url = https://xxxx/bucket2
# 文件服务器外网区访问根地址
guthon.file-service.oss.root-domain=https://xxxx
# 文件服务适配器：固定值不可修改
guthon.file-service.adapter = com.guthon.plugin.oss.aws.comps.AwsFileService
# 文件服务内网访问地址
guthon.file-service.oss.ip = http://64.97.155.195:8060
# 文件服务器私有存储区（bucket）桶
guthon.file-service.oss.private-bucket = bucket-1
# 文件服务器公有存储区（bucket）桶（需要将此桶设置为可匿名访问）
guthon.file-service.oss.public-bucket = bucket-2 
# 文件服务器通信编码
guthon.file-service.oss.access-key = ak
# 文件服务器通信秘钥
guthon.file-service.oss.secret-key = sk
# 区域编码，不是所有云存储都需要的，此处按需填写
guthon.file-service.oss.region = 
```
5. 重启服务后，文件服务即可生效，开发者不需要额外处理，附件上传就会把文件上传到云存储服务。
6. 关于HTTP代理，本插件支持HTTP代理设置，设置方法同谷神HTTP代理设置方法。
7. 包含依赖包及版本：

序号|groupId				|artifactId			  |版本
:-|:-						|:-							|:-
1 | com.amazonaws						| aws-java-sdk-s3 			| 1.12.552
2 | com.amazonaws						| aws-java-sdk-kms 			| 1.12.552
3 | com.amazonaws						| aws-java-sdk-core 		| 1.12.552
4 | com.amazonaws						| jmespath-java 			| 1.12.552
5 | software.amazon.ion					| ion-java 					| 1.0.2
6 | joda-time							| joda-time 				| 2.8.1
7 | com.fasterxml.jackson.dataformat	| jackson-dataformat-cbor 	| 2.13.5