[TOC]

# Linux服务 (X86)
#### 下载地址
- 服务器上直接下载
```shell
[root@localhost]$ wget https://file.guthon.com/fileservice/download/guthon-servo-client-3.0.x86_64.rpm
```
- 安装包文件下载（离线安装包）：[guthon-servo-client-3.0.x86_64.rpm](https://file.guthon.com/fileservice/download/guthon-servo-client-3.0.x86_64.rpm)

#### 服务安装
- 下载安装包后，上传到服务器，并执行安装命令
```shell
[root@localhost]$ rpm -ivh guthon-servo-client-3.0.x86_64.rpm
```
- 安装参数：
 - 安装路径固定在 `/opt/guthon/servo-client` 目录，且不可更改。
 - 服务监听端口固定为`7081`且不可更改，安装服务会自动开启此端口防火墙访问。
 - 注册服务名称`servoclient`

#### 服务管理
安装程序会自动注册linux服务`servoclient`，您可以通过linux服务管理命令来管理此服务，管理命令操作如下：
```shell
[root@localhost]$ systemctl status servoclient
[root@localhost]$ systemctl start servoclient
[root@localhost]$ systemctl stop servoclient
```
> [info] 当操作系统重启时，本服务会随系统一起启动

#### 服务卸载
```shell
[root@localhost]$ systemctl stop servoclient
[root@localhost]$ rpm -e guthon-servo-client
```
> [info] 若删除失败，则可以尝试强制删除命令 `rpm -e guthon-servo-client --noscripts`


# Windows
#### 下载地址
- 安装包文件下载（离线安装包）： [servoclient-setup-3.0.exe](https://file.guthon.com/fileservice/download/servoclient-setup-3.0.exe)

#### 服务安装
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;直接双击启动安装程序即可，安装程序默认安装路径为`d:\guthon\servoclient`，若服务器上无`D`盘则可以把D盘改为您需要安装的盘符（不建议安装在C盘），其他保持不变，如改为：`e:\guthon\servoclient`
> [danger] 请注意：安装路径不可包含中文、空格、特殊字符。

- 安装参数：
 - 服务监听端口固定为`7081`且不可更改，安装服务会自动开启此端口防火墙访问。
 - 注册Windows服务名称`谷神运管平台主机客户端服务`

#### 服务管理
安装程序会自动注册Windows服务`谷神运管平台主机客户端服务`，您可以通过Windows的服务管理器来管理本服务。
> [info] 当操作系统重启时，本服务会随系统一起启动

#### 服务卸载
直接执行安装目录(如：D:\guthon\servoclient)下的卸载程序`uninst.exe`即可卸载本服务及已注册的Windows服务。

# 其他服务器（Unix、Mac或其他Linux架构，如：ARM、龙芯、RISC-V等）
#### 下载地址
- 服务器上直接下载
```shell
[root@localhost]$ wget https://file.guthon.com/fileservice/download/guthon-servo-client-3.0.zip
```
- 安装包文件下载（离线安装包）：[guthon-servo-client-3.0.zip](https://file.guthon.com/fileservice/download/guthon-servo-client-3.0.zip)

#### 服务安装
- 先确定客户端服务安装路径，如：/opt/guthon
- 上传安装包后，解压缩安装包：
```shell
[root@localhost]$ unzip guthon-servo-client-3.0.zip -d /opt/guthon
[root@localhost]$ cd /opt/guthon/servo-client
```
- 赋予可执行权限:
```shell
[root@localhost servo-client]$ chmod a+x service.sh
```
- 修改启动文件中JDK路径
```shell
[root@localhost]$ vi /opt/guthon/servo-client/service.sh
```
![](http://docs.guthon.com/uploads/gdfaas/images/m_6720ffb6b1785c0a7dc4d09925a7de03_r.png)


- 安装服务（以典型Linux系统为例，其他系统视各自配置规则）
```shell
[root@localhost servo-client]$ cp servoclient.service /usr/lib/systemd/system/servoclient.service
[root@localhost servo-client]$ systemctl enable servoclient.service
[root@localhost servo-client]$ systemctl daemon-reload
```
> [info] 注意： servoclient.service 文件里，默认安装路径为 /opt/guthon/servo-client 若您自定义了安装路径，则请修改此文件里的相关路径。

- 添加防火墙端口：服务监听端口固定为`7081`且不可更改，若您已开启本地操作系统的防火墙，则请开启端口访问：
```shell
[root@localhost]$ firewall-cmd --permanent --zone=public --add-port=7081/tcp
[root@localhost]$ firewall-cmd --reload
```

#### JDK安装
请下载与您操作系统相匹配的JDK8和JDK17，并解压缩到主机客户端服务根目录（如：/opt/guthon/servo-client）下，解压缩后的目录结构：
```
/opt/guthon/servo-client/jdk8/bin/java
/opt/guthon/servo-client/jdk17/bin/java
```

#### 服务管理
您可以通过linux服务管理命令来管理此服务，管理命令操作如下：
```shell
[root@localhost]$ systemctl status servoclient
[root@localhost]$ systemctl start servoclient
[root@localhost]$ systemctl stop servoclient
```
#### 服务卸载
直接删除安装目录以及相关服务即可.
```shell
[root@localhost]$ systemctl stop servoclient
[root@localhost]$ systemctl disable servoclient
[root@localhost]$ rm -f /usr/lib/systemd/system/servoclient.service
[root@localhost]$ systemctl daemon-reload
[root@localhost]$ rm -rf /opt/guthon/servo-client
```

> [warning] 请注意：
1、主机客户端服务监听端口为[7081]，请确保您服务器上没有此端口监听的服务
2、主机客户端服务不允许暴露在公网。