- #### GuthonScript Language基本语法

 `GuthonScript`语言中，所有变量必须以`$`开头；所有指令必须以`#`开头；调用自定义函数时，必须在函数名称前加上`@`，且除`字符串块`语法外，其他所有指令语法要求一条语句必须一行完成，不可以换行，如：

 > [success] 正确示例（一条指令行语句必须在一行内完成，不可换行）

 ```
	#set($var=1)
	#set($str=$var + '0000') // 结果：$str='10000'
 ```

 > [danger] 错误示例

 ```
#set($var=1)
#set($str=$var +
	'0000') // 此处编译器会报异常错误
 ```



<br/>

 - #### 单行注释
`GuthonScript`语言中，单行注释采用“`// 注释内容`”来实现，如：

 ```java
	// 这里是注释
	#set($var=1) // 单行注释也可以写在这里
 ```

<br/>

 - #### 多行注释
`GuthonScript`语言中，多行注释采用“`/* 注释内容 */`”结尾来实现，如：

 ```java
	/*
	这里代码被注释了
	#set($var=1)
	*/

	#set($var=0) // 这里代码可以正常执行
```

<br/>

 - #### 字符串定义
`GuthonScript`语言中，定义字符串常量可以采用两个`'`或者两个`"`来表示，不限定使用单引号还是双引号。
 ```
#set($str="这个是一个字符串，'中间包含有单引号'")
```

 - #### 字符串拼接
 `GuthonScript`语言中，您可以和编写`JAVA`代码一样，直接对字符串进行相加操作，或者也可以调用内部函数对字符串进行拼接。
 
 ```
#set($num=1)
#set($str='MB' + 2019 + $num) // 得到$str值为：'MB20191'
#set($str=$vs.util.concat($num,'0000')) // 得到$str值为：10000

 ```
>[warning] 请注意

 **GuthonScript**语言只支持字符串相加，不支持数字直接相加操作，要数字直接相加减请用 `$vs.util.precise(a,b,stropt)`
 
 - #### 字符串块
 `GuthonScript`语言中，若您需要处理大批量的字符串（如查询SQL）则可以使用字符串块语法，以方便代码的阅读，字符串块的开头和结尾必须用```符号表示（反单引号，位于键盘左上角的`~`键盘）
![](http://docs.steel56.com.cn/uploads/gdfaas/images/m_7ba7193af923ee73a72bba470b05cba5_r.png)
 > [success] 字符串块语法支持变量拼接，如：${form.name} 则会取 $form.name 的值加以替换。
 
 >[warning] 请注意：字符串块内的所有字符（含不可见字符，如：回车、换行、制表等）都会算到字符串内容内。
 - #### 数字定义
 `GuthonScript`语言中，数字直接填写数字字符即可。
 
  ```
#set($num=1) // 这是一个int类型
#set($dub=1d) // 这是一个double类型
```

 - #### 三元表达式
 为了精简代码，自1.4.0版本后，谷神脚本新增对三元表达式语法的支持，语法定义如下：
 `结果值 = <判断条件> ? <符合判断条件执行> : <不符合判断条件执行>`
 
 三元表达式示例：
 
 ```
 #set($var = $form and $vs.util.isNotNull($form.BILL_NO)) ? 1 : 0) 
 ```