`GuthonScript`语言中，变量以“`$`”开头，如：
```
#set($var=1)
```

在实际开发中，一般不需要事先定义变量，直接使用`#set`语句对变量初始化即可，除非特殊场合需要特殊的集合变量时，则需要调用内置变量方法（如：`$vs.util.newMap()`）进行变量初始化工作。

### 特殊变量定义
系统内置变量提供了两个变量类型的定义方法，分别是：
- 对象定义方法：
```
	#set($var=$vs.util.newMap()) // 定义一个MAP类型的变量
	#set($var.FIELD=1234)
	$vs.log.info($var)
```
- 集合定义方法
```
	#set($var=$vs.util.newList()) // 定义一个LIST类型的变量
	$var.add($item)
	$vs.log.info($var)
```

### 系统保留变量
目前，`GuthonScript`语言中的系统保留变量只有：`$index`一个，`$index`不允许用户代码对其直接赋值，如：

```
	#set($index=1) // 此处将报异常
```